// ACQUISIZIONE AD DA UN(DUE) CANAL(I) E TRASMISSIONE SU SERIALE

#include <p18cxxx.h>   /* for TRISA and PORTA declarations */
#include <stdio.h>
#include <usart.h>

#pragma config OSC = INTIO67  // Oscillatore interno
#pragma config WDT = OFF
#pragma config LVP = OFF

void main()
{
 unsigned int i = 0, ris0, ris1;

 OSCCON = 0x72;  // se voglio usare l'oscillatore interno a 8 MHZ
 	
// ATTENZIONE: INIZIALIZZAZIONE UART:  /* no TX e RX interrupt, 8 bit, No parity, 1 stop, non disabilita RX dopo ricezione, baud rate alto: baud rate = (Fclock / 1024 * 51) - 1
// In realt sono solo 2 parametri; il primo  una maschera da caricare in TXSTA e RXSTA, il secondo  il baud rate divisor.
 OpenUSART(USART_TX_INT_OFF & USART_RX_INT_OFF & USART_ASYNCH_MODE & USART_EIGHT_BIT & USART_CONT_RX & USART_BRGH_HIGH, 51);                

 puts("Ciao! Questo  il programma di acquisizione\n\r");
 
 ADCON1 = 0x3d; // + e - vrif da esterno, ch0 ch1 porta A ingresso analogico
 
 while(1)
 {
    ADCON0 = 0x03;  // SOC:   0x02  la maschera per il bit GO in ADCON0...seleziono il canale 0, abilito l'AD
 
    while(ADCON0 & 0x02); // attesa EOC 
    // leggo il risultato che  giustificato a sinistra
    ris0 = ADRES >> 6; // traslo di 6 perch i 10 bit sono giustif a sx

    ADCON0 = 0x07;  // SOC:   0x02  la maschera per il bit GO in ADCON0...seleziono il canale 1, abilito l'AD
 
    while(ADCON0 & 0x02); // attesa EOC 
    // leggo il risultato che  giustificato a sinistra
    ris1 = ADRES >> 6; // traslo di 6 perch i 10 bit sono giustif a sx

    printf("Acquisizione %i:  ch0: %i  ch1: %i\x0a\x0d", i, ris0, ris1);

	i++;
 }
}


