// ACQUISIZIONE AD DA OTTO CANALI E TRASMISSIONE SU SERIALE
// Le acquisizioni sono a 13 bit con la tecnica di oversampling e decimazione
// Poich il micro converte a 10 bit per arrivare a 13 bit Servono 2^2*3=64 campioni
// da sommare e decimare. 64 campioni a 10 bit sommati danno un numero a 16 bit, quindi
// alla fine scarteremo i 3 bit meno significativi.

#include <p18cxxx.h>   /* for TRISA and PORTA declarations */
#include <stdio.h>
#include <usart.h>

#pragma config OSC = HS // oscillatore al quarzo a 16MHz

// no TX interrupt no RX interrupt UART mode 8 bit No parity 1 stop  non disabilita dopo 1 RX aud rate alto
#define PROTOCOL  USART_TX_INT_OFF & USART_RX_INT_OFF & USART_ASYNCH_MODE & USART_EIGHT_BIT & USART_CONT_RX & USART_BRGH_HIGH

unsigned int acq(unsigned char ch);  // ROUTINE DI ACQUISIZIONE; gli passo il canale e ritorna il valore acquisito

void main()   // main program
{
 unsigned int ch;

 OpenUSART(PROTOCOL, 103); // ATTENZIONE: INIZIALIZZAZIONE UART a 9600: formula: divisore = (Fosc / 16*baudrate) - 1

 puts("Ciao! Questo  il programma AD3:");
 
 ADCON1 = 0x04;        // + e - vrif da alimentazione, canali  AN 0-10 porta A ingressi analogici
 ADCON2bits.ADFM = 1;  // risultato giustif a destra, acqt = 0 TAD, prescaler = 1/2 -> acquisizioni a 4MHz / (10bit+1) 363KHz
 
 while(1)  { for(ch = 0; ch < 8; ch++) printf("  ch %u: %u ", ch, acq(ch));  printf("\x0d\x0a"); }
}

///////////////////////////////////////////////////////////////////////////////////
unsigned int acq(unsigned char ch)  // ROUTINE DI ACQUISIZIONE
{
  unsigned int i, val = 0;  // attenzione a azzerare val...

  if(ch >= 5) ch += 3; // correzione per canali mancanti sui 28 pin

  for(i = 0; i < 64; i++) // sommo 64 campioni per guadagnare 3 bit di risoluzione (oversampling AD) -> 363KHz/64->5680 campioni
  {
   ADCON0 = 0x03 | (ch << 2);  // SOC:   0x02  la maschera per il bit GO in ADCON0...seleziono il canale, abilito l'AD
 
   while(ADCON0 & 0x02); // attesa EOC

   val+= ADRES;  // uso risultato giustif a destra leggendolo come intero a 16 bit
  }

  val = val >> 3; // traslo di 3 bit per scalare il risultato a 13 bit significativi

  return(val);    // campione a 12 bit
}

